/*
    Copyright (C) 2012 NewestTools.com(AlexLe)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef _PARAMS_UTIL_H_
#define _PARAMS_UTIL_H_

__inline
void
VBoxUINT32ParamSet(
    VBOXHGCMSVCPARM *pParm,
    uint32_t Param
    )
{
    pParm->u.uint32 = Param;
    pParm->type = VBOX_HGCM_SVC_PARM_32BIT;
}

__inline
bool
VBoxUINT32ParamGet(
    VBOXHGCMSVCPARM *pParm,
    uint32_t *pParam
    )
{
    if ( VBOX_HGCM_SVC_PARM_32BIT == pParm->type )
    {
        *pParam = pParm->u.uint32;
        return true;
    }

    return false;
}

__inline
void
VBoxUINT64ParamSet(
    VBOXHGCMSVCPARM *pParm,
    uint64_t Param
    )
{
    pParm->u.uint64 = Param;
    pParm->type = VBOX_HGCM_SVC_PARM_64BIT;
}

__inline
bool
VBoxUINT64ParamGet(
    VBOXHGCMSVCPARM *pParm,
    uint64_t *pParam
    )
{
    if ( VBOX_HGCM_SVC_PARM_64BIT == pParm->type )
    {
        *pParam = pParm->u.uint64;
        return true;
    }

    return false;
}


__inline
void
VBoxPointerParamSet(
    VBOXHGCMSVCPARM *pParm,
    void *pBuff,
    uint32_t BuffSize
    )
{
    pParm->u.pointer.addr = pBuff;
    pParm->u.pointer.size = BuffSize;
    pParm->type = VBOX_HGCM_SVC_PARM_PTR;
}

__inline
bool
VBoxPointerParamGet(
    VBOXHGCMSVCPARM *pParm,
    void **ppBuff,
    uint32_t *pBuffSize
    )
{
    if ( VBOX_HGCM_SVC_PARM_PTR == pParm->type )
    {
        *ppBuff = pParm->u.pointer.addr;
        *pBuffSize = pParm->u.pointer.size;
        return true;
    }
    
    return false;
}

#endif
