/*
    Copyright (C) 2012 NewestTools.com(AlexLe)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef _EXPLORER_CONTEXT_MENU_H_
#define _EXPLORER_CONTEXT_MENU_H_

#include <windows.h>
#include <shlobj.h>
#include "DllMain.h"

#include <string>
using namespace std;

class CExplorerContextMenu : public IContextMenu, IShellExtInit
{

public:

    CExplorerContextMenu() { m_cRef = 0; g_DllRefs++; }
    ~CExplorerContextMenu() { g_DllRefs--; }

    //IUnknown

    STDMETHODIMP         QueryInterface(REFIID riid, PVOID *ppv);
    STDMETHODIMP_(ULONG) AddRef();
    STDMETHODIMP_(ULONG) Release();

    //IShellExtInit

    STDMETHODIMP
    Initialize(
        LPCITEMIDLIST pIDFolder,
        LPDATAOBJECT pDataObj,
        HKEY hKeyID
        );

    //IContextMenu

    STDMETHODIMP
    QueryContextMenu(
        HMENU hShellMenu,
        UINT indexMenu,
        UINT idCmdFirst,
        UINT idCmdLast,
        UINT uFlags
        );

    STDMETHODIMP InvokeCommand( LPCMINVOKECOMMANDINFO lpcmi );

    STDMETHODIMP 
    GetCommandString(
        UINT_PTR idCmd,
        UINT uFlags,
        UINT FAR* reserved,
        LPSTR pszName,
        UINT ccMax
        ){ return NOERROR; }







private:

    ULONG   m_cRef;
    wstring m_Folder;

}; //CExplorerContextMenu


#endif //_EXPLORER_CONTEXT_MENU_H_

