
;    Copyright (C) 2012 NewestTools.com(AlexLe)
;
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program.  If not, see <http://www.gnu.org/licenses/>. 

;Inno script file

#define APP_NAME "VMTransferFiles Guest OS Module"
#define APP_VER "1.0"
#define BETA_STR ""
#define SHELLEXT_NAME "VMTransferFiles"
#define APP_MUTEX_NAME "VMTransferFilesGuestSetupMtx"

[Setup]

AppName = {#APP_NAME}
AppVerName = {#APP_NAME} {#APP_VER} {#BETA_STR}
OutputBaseFilename = setup_guest
OutputDir=..\out\installers
;SetupIconFile=..\GuestShellDll\Enabled.ico
VersionInfoVersion = {#APP_VER}
VersionInfoTextVersion = {#APP_VER}
AppId = {#APP_NAME}
PrivilegesRequired = admin
UsePreviousAppDir = yes
CreateUninstallRegKey = yes
MinVersion = 0, 4.0

DefaultGroupName = {#APP_NAME}
DefaultDirName = {pf32}\{#APP_NAME}

LicenseFile=license.txt

[CustomMessages]

MsgConnectionToHostOSFailed=Cannot connect to VirtualBox Host OS.%nMake sure that Windows Guest Additions are installed.%nAlso note that you should run this setup inside VirtualBox.


[Files]

Source:"..\out\GuestShellDll.dll";DestDir: "{app}";DestName:"GuestShellDll.dll";Flags:restartreplace uninsrestartdelete ignoreversion
Source:"..\out\GuestShellDll64.dll";DestDir: "{app}";DestName:"GuestShellDll64.dll";Flags:restartreplace uninsrestartdelete ignoreversion; Check: IsWin64
Source:"license.txt";DestDir: "{app}";DestName:"Copying";Flags:restartreplace uninsrestartdelete ignoreversion
Source:"..\out\GuestServHost.exe";DestDir: "{app}";Flags:restartreplace uninsrestartdelete ignoreversion
Source:"..\out\GuestServHostAsAdmin.exe";DestDir: "{app}";Flags:restartreplace uninsrestartdelete ignoreversion
Source:"..\out\InnoInstExt.dll";DestName:"InnoInstExt.dll"; DestDir: "{app}"; Flags:restartreplace uninsrestartdelete ignoreversion
Source:"..\out\ShellNotifyAppGuest.exe";DestDir: "{app}"; DestName: "VMTransferFiles.exe"; Flags:restartreplace uninsrestartdelete ignoreversion

[Registry]

Root: HKLM32; Subkey: "Software\Microsoft\Windows\CurrentVersion\Run";ValueType: string; ValueName: "VMClipGServ"; ValueData: """{app}\GuestServHost.exe"""; Flags: uninsdeletevalue;

;32bit
Root: HKCR32; Subkey: "CLSID\{{337EAE8F-978A-478E-87FD-8E38B23FA896}"; ValueType: string; ValueName: ""; ValueData: "{#SHELLEXT_NAME} Context Menu"; Flags: uninsdeletekey;
Root: HKCR32; Subkey: "CLSID\{{337EAE8F-978A-478E-87FD-8E38B23FA896}\InProcServer32"; ValueType: string; ValueName: ""; ValueData: "{app}\GuestShellDll.dll"; Flags: uninsdeletekey;
Root: HKCR32; Subkey: "CLSID\{{337EAE8F-978A-478E-87FD-8E38B23FA896}\InProcServer32"; ValueType: string; ValueName: "ThreadingModel"; ValueData: "Apartment"; Flags: uninsdeletekey;
Root: HKCR32; Subkey: "*\shellex\ContextMenuHandlers\{#SHELLEXT_NAME}"; ValueType: string; ValueName: ""; ValueData: "{{337EAE8F-978A-478E-87FD-8E38B23FA896}"; Flags: uninsdeletekey;
Root: HKCR32; Subkey: "Directory\shellex\ContextMenuHandlers\{#SHELLEXT_NAME}"; ValueType: string; ValueName: ""; ValueData: "{{337EAE8F-978A-478E-87FD-8E38B23FA896}"; Flags: uninsdeletekey;
Root: HKCR32; Subkey: "Directory\Background\shellex\ContextMenuHandlers\{#SHELLEXT_NAME}"; ValueType: string; ValueName: ""; ValueData: "{{337EAE8F-978A-478E-87FD-8E38B23FA896}"; Flags: uninsdeletekey;
Root: HKCR32; Subkey: "Folder\ShellEx\ContextMenuHandlers\{#SHELLEXT_NAME}"; ValueType: string; ValueName: ""; ValueData: "{{337EAE8F-978A-478E-87FD-8E38B23FA896}"; Flags: uninsdeletekey;
Root: HKCR32; Subkey: "InternetShortcut\ShellEx\ContextMenuHandlers\VMTransferFilesExtension"; ValueType: string; ValueName: ""; ValueData: "{{337EAE8F-978A-478E-87FD-8E38B23FA896}"; Flags: uninsdeletekey;
Root: HKCR32; Subkey: "lnkfile\shellex\ContextMenuHandlers\VMTransferFilesExtension"; ValueType: string; ValueName: ""; ValueData: "{{337EAE8F-978A-478E-87FD-8E38B23FA896}"; Flags: uninsdeletekey;
Root: HKLM32; Subkey: "Software\Microsoft\Windows\CurrentVersion\Shell Extensions\Approved";ValueType: string; ValueName: "{{337EAE8F-978A-478E-87FD-8E38B23FA896}"; ValueData: "{#SHELLEXT_NAME} Context Menu"; Flags: uninsdeletevalue;

;64bit
Root: HKCR64; Subkey: "CLSID\{{337EAE8F-978A-478E-87FD-8E38B23FA896}"; ValueType: string; ValueName: ""; ValueData: "{#SHELLEXT_NAME} Context Menu"; Flags: uninsdeletekey; Check: IsWin64;
Root: HKCR64; Subkey: "CLSID\{{337EAE8F-978A-478E-87FD-8E38B23FA896}\InProcServer32"; ValueType: string; ValueName: ""; ValueData: "{app}\GuestShellDll64.dll"; Flags: uninsdeletekey; Check: IsWin64;
Root: HKCR64; Subkey: "CLSID\{{337EAE8F-978A-478E-87FD-8E38B23FA896}\InProcServer32"; ValueType: string; ValueName: "ThreadingModel"; ValueData: "Apartment"; Flags: uninsdeletekey; Check: IsWin64;
Root: HKCR64; Subkey: "*\shellex\ContextMenuHandlers\{#SHELLEXT_NAME}"; ValueType: string; ValueName: ""; ValueData: "{{337EAE8F-978A-478E-87FD-8E38B23FA896}"; Flags: uninsdeletekey; Check: IsWin64;
Root: HKCR64; Subkey: "Directory\shellex\ContextMenuHandlers\{#SHELLEXT_NAME}"; ValueType: string; ValueName: ""; ValueData: "{{337EAE8F-978A-478E-87FD-8E38B23FA896}"; Flags: uninsdeletekey; Check: IsWin64;
Root: HKCR64; Subkey: "Directory\Background\shellex\ContextMenuHandlers\{#SHELLEXT_NAME}"; ValueType: string; ValueName: ""; ValueData: "{{337EAE8F-978A-478E-87FD-8E38B23FA896}"; Flags: uninsdeletekey; Check: IsWin64;
Root: HKCR64; Subkey: "Folder\ShellEx\ContextMenuHandlers\{#SHELLEXT_NAME}"; ValueType: string; ValueName: ""; ValueData: "{{337EAE8F-978A-478E-87FD-8E38B23FA896}"; Flags: uninsdeletekey; Check: IsWin64;
Root: HKCR64; Subkey: "InternetShortcut\ShellEx\ContextMenuHandlers\{#SHELLEXT_NAME}"; ValueType: string; ValueName: ""; ValueData: "{{337EAE8F-978A-478E-87FD-8E38B23FA896}"; Flags: uninsdeletekey; Check: IsWin64;
Root: HKCR64; Subkey: "lnkfile\shellex\ContextMenuHandlers\{#SHELLEXT_NAME}"; ValueType: string; ValueName: ""; ValueData: "{{337EAE8F-978A-478E-87FD-8E38B23FA896}"; Flags: uninsdeletekey; Check: IsWin64;
Root: HKLM64; Subkey: "Software\Microsoft\Windows\CurrentVersion\Shell Extensions\Approved";ValueType: string; ValueName: "{{337EAE8F-978A-478E-87FD-8E38B23FA896}"; ValueData: "{#SHELLEXT_NAME} Context Menu"; Flags: uninsdeletevalue; Check: IsWin64;

[Icons]

Name: "{group}\VMTransferFiles"; Filename: "{app}\VMTransferFiles.exe"
Name: "{group}\Uninstall {#APP_NAME}"; Filename: "{uninstallexe}"


[Run]

Filename: "{app}\GuestServHost.exe"; Flags: nowait

[Code]

procedure UninstallTerminateAppInstance();
external 'GS_HelperTerminateAppInstance@{app}\InnoInstExt.dll stdcall uninstallonly';

procedure InstallTerminateAppInstance();
external 'GS_HelperTerminateAppInstance@files:InnoInstExt.dll stdcall delayload setuponly';



function TryConnectToHostOS() : BOOL;
external 'TryConnectToHostOS@files:GuestShellDll.dll stdcall delayload setuponly';

function CheckIfAnotherSetupRunning() : Boolean;
begin

    if CheckForMutexes( '{#APP_MUTEX_NAME}' ) then
    begin
        Result := True;
        Exit;
    end


    CreateMutex( '{#APP_MUTEX_NAME}' );
    Result := False;
    Exit;

end;


function InitializeSetup(): Boolean;
begin

    Result := True;
	
	Log( 'InitializeSetup - enter' );	

    //Sometimes autorun (WinXP) may execute 2 instances of setup

    if CheckIfAnotherSetupRunning() then
    begin
        Result := False;
        Exit;
    end;
	

    if not TryConnectToHostOS() then
    begin
        MsgBox( CustomMessage( 'MsgConnectionToHostOSFailed' ), mbError, MB_OK );
        Result := False;
        Exit;
    end;

     ExtractTemporaryFile( 'InnoInstExt.dll' );
	 
	Log( 'InitializeSetup - exit' );		 


end;

procedure CurStepChanged(CurStep: TSetupStep);
begin

  if CurStep = ssInstall then
  begin    
    Log( 'InstallTerminateAppInstance - pre' );
    InstallTerminateAppInstance();
	Log( 'InstallTerminateAppInstance - after' );
  end;

end;

procedure CurUninstallStepChanged(CurUninstallStep: TUninstallStep);
begin

    if  CurUninstallStep = usUninstall then
    begin
      UninstallTerminateAppInstance();
      UnloadDLL(ExpandConstant('{app}\InnoInstExt.dll'));
    end;

end;

