/*
    Copyright (C) 2012 NewestTools.com(AlexLe)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "Settings.h"
#include "Globals.h"

//------------------------------------------------

#ifndef KEY_WOW64_64KEY
#define KEY_WOW64_64KEY 0x100
#endif

//------------------------------------------------

BOOL
Settings_IsWin64();

BOOL
Settings_BeepAfterCopyingFiles();

BOOL
Settings_DragDropEnabled();

//__success(return == ERROR_SUCCESS )
DWORD
Settings_QueryDwordValue(
	IN LPCSTR lpszValueName,
	OUT DWORD *pdwValue
	);

//------------------------------------------------

BOOL
Settings_IsWin64()
{
	typedef ULONG (__stdcall *TGetSystemWow64DirectoryA)( LPCSTR lpszBuff, ULONG Size );
	
	TGetSystemWow64DirectoryA pfnGetSystemWow64DirectoryA = (TGetSystemWow64DirectoryA)GetProcAddress(
		GetModuleHandleA( "kernel32.dll" ),
		"GetSystemWow64DirectoryA"
		);
		
	if ( pfnGetSystemWow64DirectoryA )
	{
		CHAR szPath[ MAX_PATH ] = "";
		
		ULONG uRet = pfnGetSystemWow64DirectoryA(
			szPath,
			sizeof(szPath)/sizeof(szPath[0])
			);
			
		if ( !(uRet == 0 && ERROR_CALL_NOT_IMPLEMENTED == GetLastError() ) )
		{
			return TRUE;
		}
	}
		
	return FALSE;
	
}

BOOL
Settings_BeepAfterCopyingFiles()
{
	BOOL bDefault = TRUE;
	DWORD dwValue = bDefault;

	Settings_QueryDwordValue(
		"BeepAfterCopyingFiles",
		&dwValue
		);

	return dwValue;
}


BOOL
Settings_DragDropEnabled()
{
	BOOL bDefault = TRUE;
	DWORD dwValue = bDefault;

	Settings_QueryDwordValue(
		"DragDropEnabled",
		&dwValue
		);

	return dwValue;
}

//__success(return == ERROR_SUCCESS )
DWORD
Settings_QueryDwordValue(
	IN LPCSTR lpszValueName,
	OUT DWORD *pdwValue
	)
{
	HKEY hKey = NULL;

	int ret = RegOpenKeyEx(
		HKEY_CURRENT_USER,
		"Software\\"APP_NAMEA,
		0,
		Settings_IsWin64() ? KEY_QUERY_VALUE | KEY_WOW64_64KEY : KEY_QUERY_VALUE,
		&hKey
		);

	if ( ret != ERROR_SUCCESS )
	{
		return ret;
	}

	DWORD dwType = REG_DWORD;
	DWORD dwValue  = 0;
	DWORD cbValue = sizeof(dwValue);

	ret = RegQueryValueEx(
		hKey,
		lpszValueName,
		NULL,
		&dwType,
		(LPBYTE)&dwValue,
		&cbValue
		);

	RegCloseKey( hKey );

	if ( ret != ERROR_SUCCESS )
	{
		return ret;
	}

	if ( dwType != REG_DWORD || cbValue != sizeof(DWORD)  )
	{
		return ERROR_INVALID_DATATYPE;
	}

	*pdwValue = dwValue;
	return ERROR_SUCCESS;
}

